#
# spec file for package ghc-boring
#
# Copyright (c) 2024 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name boring
%global pkgver %{pkg_name}-%{version}
Name:           ghc-%{pkg_name}
Version:        0.2.2
Release:        1.2
Summary:        Boring and Absurd types
License:        BSD-3-Clause
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-tagged-devel
BuildRequires:  ghc-tagged-prof
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-transformers-prof
ExcludeArch:    %{ix86}

%description
* 'Boring' types are isomorphic to '()'.

* 'Absurd' types are isomorphic to 'Void'.

See [What does () mean in Haskell -answer by Conor
McBride](https://stackoverflow.com/questions/33112439/what-does-mean-in-haskell/33115522#33115522).

%package devel
Summary:        Haskell %{pkg_name} library development files
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%package -n ghc-%{pkg_name}-doc
Summary:        Haskell %{pkg_name} library documentation
Requires:       ghc-filesystem
BuildArch:      noarch

%description -n ghc-%{pkg_name}-doc
This package provides the Haskell %{pkg_name} library documentation.

%package -n ghc-%{pkg_name}-prof
Summary:        Haskell %{pkg_name} profiling library
Requires:       ghc-%{pkg_name}-devel = %{version}-%{release}
Supplements:    (ghc-%{pkg_name}-devel and ghc-prof)

%description -n ghc-%{pkg_name}-prof
This package provides the Haskell %{pkg_name} profiling library.

%prep
%autosetup -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc ChangeLog.md

%files -n ghc-%{pkg_name}-doc -f ghc-%{pkg_name}-doc.files
%license LICENSE

%files -n ghc-%{pkg_name}-prof -f ghc-%{pkg_name}-prof.files

%changelog
* Fri May 17 2024 Peter Simons <psimons@suse.com>
- Update boring to version 0.2.2.
  [#]# 0.2.2
  - Support GHC-8.6.5...9.10.1
* Wed Oct 11 2023 Peter Simons <psimons@suse.com>
- Update boring to version 0.2.1 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Thu Mar 30 2023 Peter Simons <psimons@suse.com>
- Updated spec file to conform with ghc-rpm-macros-2.5.2.
* Wed Mar 15 2023 Peter Simons <psimons@suse.com>
- Update boring to version 0.2.1.
  [#]# 0.2.1
  - Add instances for `SNat`, `SSymbol`, and `SChar`
    (singletons introduced in `base-4.18.0.0`)
* Tue Mar 14 2023 Peter Simons <psimons@suse.com>
- Update boring to version 0.2 revision 3.
  Upstream has revised the Cabal build instructions on Hackage.
* Sun Aug 21 2022 Peter Simons <psimons@suse.com>
- Update boring to version 0.2 revision 2.
  Upstream has revised the Cabal build instructions on Hackage.
* Sat Dec 11 2021 Peter Simons <psimons@suse.com>
- Update boring to version 0.2 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Mon Apr  5 2021 psimons@suse.com
- Add boring at version 0.2.
